<template>
  <transition :enter-active-class="enterClass()" leave-active-class="animated zoomOut">
    <div v-if="current" class="survey-slide">
      <div class="left noselect">
        <transition enter-active-class="animated zoomIn" leave-active-class="animated fadeOut">
          <div class="arrow" v-if="slide.previous" @click="previous()">
            <i class="fa fa-angle-left"></i>
          </div>
        </transition>
      </div>
      <div class="center">
        <p class="caption" v-if="caption"><span v-html="caption"></span></p>
        <p class="title" v-if="title"><span v-html="title"></span></p>
        <p class="text" v-if="text"><span v-html="text"></span></p>
        <p class="footnote" v-if="footnote"><span v-html="footnote"></span></p>
        <survey-inputs :name="slide.name" />
        <survey-total :name="slide.name" />
      </div>
      <div class="right noselect">
        <transition enter-active-class="animated zoomIn" leave-active-class="animated fadeOut">
          <div class="arrow" v-if="slide.next" @click="next()">
            <i class="fa fa-angle-right"></i>
          </div>
        </transition>
      </div>
    </div>
  </transition>
</template>

<script>
  import Store from '../stores/app.store';
  import SurveyInputs from './inputs';
  import SurveyTotal from './total';

  export default {
    components: { SurveyInputs, SurveyTotal },
    name: "survey-slide",
    props: [ 'name' ],
    computed: {
      current() { return Store.getters.isCurrent(this.name); },
      caption() { return Store.getters.text(this.slide.caption); },
      title() { return Store.getters.text(this.slide.title); },
      text() { return Store.getters.text(this.slide.text); },
      footnote() { return this.slide.notes ? Store.getters.text(this.slide.notes.text) : null; }
    },
    data: function() {
      return {
        slide: Store.getters.slide(this.name)
      }
    },
    methods: {
      enterClass: function() {
        if (this.slide.state == 'entering-left')
          return 'animated fadeInLeft';

        if (this.slide.state == 'entering-right')
          return 'animated fadeInRight';

        return null;
      },

      next: function() {
        Store.commit('nextSlide');
      },

      previous: function() {
        Store.commit('previousSlide');
      }
    },
  }
</script>

<style scoped>
  .caption {
    font-weight: 200;
    font-size: 1.2em;
    text-transform: uppercase;
  }

  .title {
    font-size: 2.5em;
    font-weight: 600;
    margin: .6em 0 1.2em 0;
    line-height: 1.2em;
  }

  .text {
    text-transform: uppercase;
  }

  .footnote {
    font-size: .8em;
    margin-top: -.9em;
  }

  .survey-slide {
    position: absolute;
    display: flex;
    flex-wrap: nowrap;
    margin: 2em 0;
    width: 100%;
    background-color: #fff;
    border: 1px solid #ccc;
    text-align: center;
  }

  .left, .right, .center {
    flex-grow: 1;
    font-size: 9em;
    min-height: 3em;
    padding: 0 .1em;
  }

  .left {
    text-align: left;
  }

  .right {
    text-align: right;
  }

  .center {
    background-color: #fff;
    font-size: 1em;
    padding: 2em 4em;
    flex-grow: 20;
  }

  .arrow {
    cursor: pointer;
    padding: .3em 0;
    opacity: .15;
    transition: opacity, .8s;
  }

  .arrow:hover {
    opacity: 1;
    transition: opacity, .2s;
  }

  *.noselect {
     -moz-user-select: -moz-none;
     -khtml-user-select: none;
     -webkit-user-select: none;

     /*
       Introduced in IE 10.
       See http://ie.microsoft.com/testdrive/HTML5/msUserSelect/
     */
     -ms-user-select: none;
     user-select: none;
  }
</style>
